/*
 * TreeInitializationC.h - Simpe initialization unit.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 07-Aug-1998
 *
 */

#ifndef TreeInitializationC_h
#define TreeInitializationC_h 1

#include <Core/InitializationA.h>

#include <ConfigurationA.h>
#include "TreeDataC.h"
#include "GP_NodeA.h"
#include "DataBaseProblemC.h"
#include <Common/RandomA.h>

class TreeInitializationC: public InitializationA
{
	public:

		TreeInitializationC
		(
			ConfigurationA const & iConfiguration,
			ProblemA const & iProblem,
			RandomA const & iRandom
		);

		virtual ~TreeInitializationC();

		virtual void operator()
		(
			DataA & iData
		) const;

	protected:

	private:

	void
	TreeInitializationC::CreateFullTree
	(
		TreeC<GP_NodeA<bool> >::Insert_IteratorC Root,
		unsigned int Depth
	);

}; // TreeInitializationC

#endif

// Eof TreeInitializationC.h
