/*
 * InitializationC.h - Simpe initialization unit.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 19-May-1998
 *
 */

#ifndef InitializationC_h
#define InitializationC_h 1

#include "Core/InitializationA.h"

#include "ConfigurationA.h"
#include "Problem/DataA.h"
#include "Common/RandomA.h"

class InitializationC: public InitializationA
{
	public:

		InitializationC
		(
			ConfigurationA const & iConfiguration,
			ProblemA const & iProblem,
			RandomA const & iRandom
		);

		virtual ~InitializationC();

		virtual void operator()
		(
			DataA & iData
		) const;

	protected:

	private:

}; // InitializationC

#endif

// Eof InitializationC.h
