/*
 * PoolIteratorA.h - Abstract base class defining the interface of a simple iterator to work with a population pool.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 24-May-1998
 *
 */

#ifndef PoolIteratorA_h
#define PoolIteratorA_h 1

#include "Core/GenotypeA.h"

//TODO: Idea: 'hide' this in PoolA?
class PoolIteratorA
{
	public:
	
		virtual ~PoolIteratorA()
		{};

		virtual void First() =0;

		virtual void Next() =0;

		virtual void Delete() =0;

		virtual bool IsDone() const=0;

		virtual GenotypeA & CurrentItem() const =0;

	protected:

	private:

}; // PoolIteratorA



class PoolConstIteratorA
{
	public:
	
		virtual ~PoolConstIteratorA()
		{};

		virtual void First() =0;

		virtual void Next() =0;

		virtual bool IsDone() const=0;

		virtual GenotypeA const & CurrentItem() const =0;

	protected:

	private:

}; // PoolConstIteratorA

#endif

// Eof PoolIteratorA.h
