/*
 * SelectParentsC.h - Simple parent selection mechanism: rank based.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 17-Jun-1998
 *
 */

#ifndef SelectParentsC_h
#define SelectParentsC_h 1

#include "Reproduction/SelectParentsA.h"

#include "Error/LibraryErrorC.h"


class SelectParentsC: public SelectParentsA
{
	public:

		SelectParentsC
		(
			ConfigurationA const & iConfiguration,
			RandomA const & iRandom
		);

		virtual ~SelectParentsC();

		virtual ArrayC<GenotypeA const *>* operator()
		(
			PoolA const & iPool
		) const;

	protected:

	private:

		double LinearRankingBias;

		double PreWork1;
		double PreWork2;
		double PreWork3;

}; // SelectParentsC

#endif

// Eof SelectParentsC.h
