/*
 * StringC.cc - Simple string implementation.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 24-May-1998
 *
 */

#include "Common/StringC.h"



//TODO Why can't we overload int, unsigned int, double and bool at the same time?
/*
StringC::operator unsigned int const() const
{
	int integer = atoi(String);
	assert(integer >= 0);

	return integer;
}



StringC::operator bool const() const
{
	if ((String == "false") || (String == "False") || (String == "FALSE") || (String == "0"))
		return false;
	else
		if ((String == "true") || (String == "True") || (String == "TRUE") || (String == "1"))
			return true;
		else
			assert (0);
}
*/



// Ctors & dtors ----------

StringC::StringC()
{
	String = strdup("");

} // StringC



StringC::StringC(StringC const & iString)
{
	String = strdup(iString.String);

} //StringC



StringC::StringC
(
	char const * const iChar
)
{
	String = strdup(iChar);

} // StringC



StringC::StringC
(
	int iInt
)
{
	// Size should be calculated
	String = new char [10];
	sprintf(String, "%i", iInt);

} // StringC



StringC::~StringC()
{
	delete String;

} // ~StringC



StringC & StringC::operator=
(
	char const * const iChar
)
{
	delete String;

	String = strdup(iChar);

	return *this ;

} // operator=



StringC & StringC::operator=
(
	StringC const & iString
)
{
	if (this != &iString)
	{
		 delete String;
		 String = strdup(iString.String);
	}
	
	return *this ;
	
} // operator=



// Other stuff ----------

bool const 
StringC::operator==
(
	StringC const & iString
) const
{
	if (strcmp(String, iString.String) == 0)
	{
		return(true);
	}
	else
	{
		return(false);
	}
} // operator==



bool const 
StringC::operator==
(
	char const * const iChar
) const
{
	if (strcmp(String, iChar) == 0)
	{
		return(true);
	}
	else
	{
		return(false);
	}
} // operator==


bool const 
StringC::operator!=
(
	StringC const & iString
) const
{
	return !(*this == iString);

} // operator!=



bool const
StringC::operator!=
(
	char const * const iChar
) const
{
	return !(*this == iChar);

} // operator!=



StringC
StringC::operator+
(
	StringC const iString
)
{
	/*StringC * s;
	s = new StringC(String);

	(*s) += iString.String;

	return s;*/

	StringC s(String);

	s += iString.String;

	return s;

} // operator+



StringC & StringC::operator+=
(
	char const * const iChar
)
{
	char * s;

	s = strdup(String);
	delete String;

	String = new char [strlen(iChar) + strlen(s) + 1];
	String = strcpy(String, s);
	String = strcat(String, iChar);

	delete s;
	/*realloc(String, sizeof(iChar) + sizeof(String));
	String = strcat(String, iChar);*/

	return *this ;
	
} // operator+=



StringC & StringC::operator+=
(
	StringC const iString
)
{
	char * s;

	s = strdup(String);
	delete String;

	String = new char [strlen(iString.String) + strlen(s) + 1];
	String = strcpy(String, s);
	String = strcat(String, iString.String);

	delete s;
	/*realloc(String, sizeof(iString.String) + sizeof(String));
	String = strcat(String, iString.String);*/
	
	return *this ;

} // operator+=



// Input & output -------------

ostream & operator<<
(
	ostream & iStream,
	const StringC & iString
)
{
	iString.PrintToStream(iStream);

	return iStream;

} // operator<<



istream & operator>>
(
	istream & iStream,
	StringC & iString
)
{
	//TODO: Buffer has a fixed size, could be trouble for large input strings.
	char* buffer = new char [500];

	iStream >> buffer;

	iString = buffer;

	delete [] buffer;

	return iStream;

} // operator>>



void const StringC::PrintToStream
(
	ostream & iStream
) const
{
	iStream << setw(iStream.width()) << String;

} // PrintToStream



// Eof StringC.cc
