/*
 * GenotypeA.h - Abstract base class for a genotype.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 03-Jun-1998
 *
 */

#include "Core/GenotypeA.h"


unsigned int GenotypeA::Unique_ID = 0;

GenotypeA::GenotypeA
(
	ConfigurationA const & iConfiguration,
	ProblemFactoryA const & iProblemFactory
): Configuration(iConfiguration), ProblemFactory(iProblemFactory)
{
	ID = ++Unique_ID;

} // GenotypeA



GenotypeA::~GenotypeA()
{

} // ~GenotypeA


void  
GenotypeA::Evaluate
(
	FitnessFunctionA const & iFitnessFunction
)
{
	//iFitnessFunction.Calculate(*FitnessValue, *Data);

} // Evaluate



//REM:
/*
void  
GenotypeA::Copy
(
	GenotypeA const & iGenotype
)
{
	*Data = iGenotype.GetData();

	*FitnessValue = iGenotype.GetFitnessValue();

} // Copy
*/



unsigned int
GenotypeA::GetUniqueID() const
{
	return ID;

} // GetUniqueID



bool 
GenotypeA::operator==
(
	GenotypeA const & iGenotype
) const
{
//	return IsEqual(iGenotype);
	return FitnessValue == iGenotype.FitnessValue;

} // operator==



bool 
GenotypeA::operator!=
(
	GenotypeA const & iGenotype
) const
{
	//return !IsEqual(iGenotype);
	return FitnessValue != iGenotype.FitnessValue;

} // operator!=



bool 
GenotypeA::operator<=
(
	GenotypeA const & iGenotype
) const
{
	//return !IsGreater(iGenotype);
	return FitnessValue >= iGenotype.FitnessValue;

} // operator<=



bool 
GenotypeA::operator>=
(
	GenotypeA const & iGenotype
) const
{
	//return !IsSmaller(iGenotype);
	return FitnessValue <= iGenotype.FitnessValue;

} // operator>=



bool 
GenotypeA::operator<
(
	GenotypeA const & iGenotype
) const
{
	//return IsSmaller(iGenotype);
	return FitnessValue > iGenotype.FitnessValue;

} // operator<=



bool
GenotypeA::operator>
(
	GenotypeA const & iGenotype
) const
{
	//return IsGreater(iGenotype);
	return FitnessValue < iGenotype.FitnessValue;

} // operator>=




// Eof GenotypeA.h
