/*
 * ExperimentA.cc - Abstract base class for an experiment manager.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 17-Jun-1998
 *
 */

#include "ExperimentA.h"



ExperimentA::ExperimentA
(
	ConfigurationA const & iConfiguration,
	StatisticsA & iStatistics,
	CoreFactoryA const & iCoreFactory,
	ProblemFactoryA const & iProblemFactory,
	ReproductionFactoryA const & iReproductionFactory,
	RandomA & iRandom
): Configuration(iConfiguration), Statistics(iStatistics), ProblemFactory(iProblemFactory), CoreFactory(iCoreFactory), ReproductionFactory(iReproductionFactory), Random(iRandom)
{
} // ExperimentA



ExperimentA::~ExperimentA()
{
} // ~ExperimentA



void
ExperimentA::OutOfMemory()
{
	//TODO: Build in savety routine that saves some results/data.
	cerr << "Error: Out of memory.\n";
	exit (1);

} // OutOfMemory



// Eof ExperimentA.cc
