/*
 * DataC.cc - Simpe example of data in the form of an array.
 *
 * Part of the Library for Evolutionary Algorithm Programming.
 *
 * Copyright (C) 1998 J.I. van Hemert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: J.I. van Hemert
 * Last Revision: 16-Jun-1998
 *
 */

#include "Problem/DataC.h"
#include "Common/ArrayC.tpl"

DataC::DataIteratorC::DataIteratorC
(
	DataIteratorA const & iDataIterator
): DataIteratorA(iDataIterator)
{
} // DataIteratorC


DataC::DataConstIteratorC::DataConstIteratorC
(
	DataConstIteratorA const & iDataConstIterator
): DataConstIteratorA(iDataConstIterator)
{
} // DataConstIteratorC


/*
DataIteratorC const &
DataIteratorC::DataIteratorC
(
	DataIteratorC const & iDataIterator
)
{

} // DataIteratorC
*/


//--------------------------

DataC const &
DataC::operator=
(
	DataC const & iData
)
{
	//TODO: Implement operator=.
	throw new LibraryErrorC("Not implemented yet (DataC::operator=).");

	return iData;
} // operator=



DataC::DataC
(
	DataC const & iData
) : DataA()
{
	*Array = *(iData.Array);
} // DataC


void DataC::PrintToStream
(
	ostream & in
) const
{
	for (unsigned int i = 0; i < Array->GetSize(); ++i)
	{
		in << (*Array)[i] << " ";
	}
} // PrintToStream

// Eof DataC.cc
